// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
)

// UserHandlerFunc turns a function with the right signature into a user handler
type UserHandlerFunc func(UserParams, *ticketboss) middleware.Responder

// Handle executing the request and returning a response
func (fn UserHandlerFunc) Handle(params UserParams, principal *ticketboss) middleware.Responder {
	return fn(params, principal)
}

// UserHandler interface for that can handle valid user params
type UserHandler interface {
	Handle(UserParams, *ticketboss) middleware.Responder
}

// NewUser creates a new http.Handler for the user operation
func NewUser(ctx *middleware.Context, handler UserHandler) *User {
	return &User{Context: ctx, Handler: handler}
}

/*User swagger:route POST /users Users user user

Create a new User.

JSON Response is provided with respective success or fail details.

*/
type User struct {
	Context *middleware.Context
	Handler UserHandler
}

func (o *User) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *ticketboss
	if uprinc != nil {
		principal = uprinc.(*ticketboss) // this is really a ticketboss, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
